package org.one.stone.soup.browser;

import java.net.*;
import java.io.*;

import org.one.stone.soup.file.*;

/*
 * Wet -Wired.com Browser Version Date 27-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.co.uk/pages/licence-os.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public class Browser {
	private static ResourceStore resourceStore;

	private static String key = null;
	private static String flavour;
	private static boolean isApplet = false;
	private static String owner;
	private static ProgressListener progressListener = null;
	
	
	
private Browser() {
	super();
}
public static void downloadResource(String url, String file)
{
 long size = 0;
 try{
	InputStream iStream = new URL(url).openStream();
	FileOutputStream oStream = new FileOutputStream(file);

	int in = iStream.read();

	while(in!=-1)
	{
		oStream.write((char)in);
		size++;

		in = iStream.read();
	}

	iStream.close();
	oStream.close();
 }
 catch(Exception e)
 {
	 e.printStackTrace();
 }

 System.out.println("Downloaded Url:"+url+" to File:"+file+" size="+size);
}
/**
 *
 * @return java.lang.String
 */
public static String getBase() {
	return BrowserURLFactory.getBase();
}
public static InputStream getInputStream(String url) throws MalformedURLException,IOException
{
	return BrowserURLFactory.getURLInputStream(flavour,url,flavour,isApplet);
}
/**
 *
 * @return java.lang.String
 */
public static String getOwner() {
	return owner;
}
/**
 *
 * @return org.one.stone.soup.file.ProgressListener
 */
private static ProgressListener getProgressListener() {
	return progressListener;
}
public static Object getResource(String url)
{
	if(resourceStore!=null)
	{
		return resourceStore.retrieve(url);
	}
	else
	{
		return null;
	}
}
public static String getURLFor(String url) throws MalformedURLException
{
	return BrowserURLFactory.getURL(url);
}
public static String initialize(boolean applet,String newFlavour)
{
	flavour = newFlavour;
	isApplet = applet;

	if(key!=null)
		return null;

	key = org.one.stone.soup.browser.security.KeyFactory.getUniqueKey("Browser");
	return key;
}
public static boolean isKey(String testKey)
{
	if(testKey.equals(key))
		return true;
	else
		return false;
}

public static OutputStream openURLPostFileStream(String url,String fileName) throws MalformedURLException,IOException
{
	return new BrowserFileOutputStream( BrowserURLFactory.openURLPostFileConnection(flavour,url),fileName );	
}

protected static void closeURLPostFileConnection(URLConnection connection,OutputStream outputStream) throws MalformedURLException,IOException
{
	BrowserURLFactory.closeURLPostFileConnection(connection,outputStream);
}

public static InputStream postFile(String url,String fileName) throws MalformedURLException,IOException
{
	InputStream fileStream = new FileInputStream(fileName);

//	String ext = FileHelper.getExt(fileName);
//	String type = org.one.stone.soup.net.MimeType.getType(ext);

	return BrowserURLFactory.getURLPostFile(flavour,url,new File(fileName).getName(),fileStream);
}
public static InputStream postForm(String url,org.one.stone.soup.util.HashedVector data) throws MalformedURLException,IOException
{
	return BrowserURLFactory.getURLPost(flavour,url,data);
}
public static InputStream setBaseURL(String url, String testKey) throws IOException
{
	if(key==null || testKey.equals(key))
	{
		InputStream iStream = BrowserURLFactory.setBase(url,flavour,progressListener,isApplet);
		owner = BrowserURLFactory.getBase();
		return iStream;
	}
	else
		return null;
}
public static void releaseKey(String testKey)
{
	if(testKey.equals(key))
	{
		key = null;
	}
}
/**
 *
 * @param newProgressListener org.one.stone.soup.file.ProgressListener
 */
public static void setProgressListener(ProgressListener newProgressListener) {
	progressListener = newProgressListener;
}

public static boolean hasResourceStore()
{
	if(resourceStore==null)
	{
		return false;
	}
	return true;
}
public static void setResourceStore(ResourceStore newResourceStore)
{
	if(resourceStore==null)
	{
		resourceStore = newResourceStore;
	}
}
public static void storeResource(String key,Object resource)
{
	if(resourceStore!=null)
	{
		resourceStore.store(key,resource);
	}
}
}
