package org.one.stone.soup.file;

import java.io.*;
import java.util.zip.*;

/*
 * Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

 /**
	* The Zipper class is a helper class that overlays an easy to use set
	* of methods on the java.util.zip classes. It allows for multiple
	* entries to the zip file, each specified as a local file name.
	* A static method is also given that will build a zip file of
	* a single local file.
	*
*/

public class Zipper{

	private FileOutputStream out;
	private ZipOutputStream zOut;

public Zipper(String zipFile) throws IOException{

	out = new FileOutputStream(zipFile);
	zOut = new ZipOutputStream(out);

	zOut.setLevel(9);
	zOut.setMethod(Deflater.DEFLATED);
}
public void addEntry(String zipEntryName, String sourceFile) throws IOException {
	this.addEntry(zipEntryName,sourceFile,true);
}
public void addEntry(String zipEntryName, String sourceFile,boolean compress) throws IOException {

	zipEntryName = zipEntryName.replace('\\','/');

		if(sourceFile==null)
		{
			if(zipEntryName.length()<1 || zipEntryName.charAt(zipEntryName.length()-2)!='/')
			{
				zipEntryName = zipEntryName+"/";
			}
			ZipEntry zEntry = new ZipEntry(zipEntryName);
			try{
				zOut.putNextEntry(zEntry);
			}
			catch(Exception e)
			{
			}
			return;
		}

	File source = new File(sourceFile);
		if(source.isDirectory())
		{
			if(zipEntryName.length()<1 || zipEntryName.charAt(zipEntryName.length()-2)!='/')
			{
				zipEntryName = zipEntryName+"/";
			}
			ZipEntry zEntry = new ZipEntry(zipEntryName);
			try{
				zOut.putNextEntry(zEntry);
			}
			catch(Exception e)
			{
			}
			return;
		}

		FileInputStream in = new FileInputStream(sourceFile);

		ZipEntry zEntry = new ZipEntry(zipEntryName);

		if(compress==true)
			zEntry.setMethod(ZipEntry.DEFLATED);
		else
			zEntry.setMethod(ZipEntry.STORED);

		zOut.putNextEntry(zEntry);

		byte[] data = new byte[10000];

		int inByte = in.read(data);

		while(inByte!=-1)
		{
			zOut.write(data,0,inByte);

			inByte = in.read(data);
		}

		zOut.closeEntry();

		in.close();
}
public void close() throws IOException {
	zOut.close();
	out.close();
}
public static void zip(String sourceFile,String zipFile,String zipEntryName) throws IOException{

	FileInputStream in = new FileInputStream(sourceFile);
	FileOutputStream out = new FileOutputStream(zipFile);
	ZipOutputStream zOut = new ZipOutputStream(out);

	zOut.setLevel(9);
	zOut.setMethod(Deflater.DEFLATED);

	ZipEntry zEntry = new ZipEntry(zipEntryName);
	zOut.putNextEntry(zEntry);

	byte[] data = new byte[10000];

	int inByte = in.read(data);

	while(inByte!=-1)
	{
		zOut.write(data,0,inByte);

		inByte = in.read(data);
	}

	zOut.closeEntry();
	zOut.close();
	in.close();
}
}
