/*
 * Created on 28-Aug-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.one.stone.soup.remote.control.server;

import java.awt.BorderLayout;
import java.awt.Frame;
import java.io.OutputStream;
import java.net.InetAddress;

import javax.swing.JLabel;

import org.one.stone.soup.screen.recorder.DesktopScreenRecorder;
import org.one.stone.soup.screen.recorder.ScreenRecorder;
import org.one.stone.soup.screen.recorder.ScreenRecorderListener;
import org.one.stone.soup.swing.JRootFrame;

/**
 * @author Nicholas Cross
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class RemoteControlServerUI extends JRootFrame implements RemoteControlServerApplication {

	private int port = 169;
	private String address;
	private String alias;
	private String password;
	
	private RemoteControlServer server;
	private RemoteControlHubConnection hubConnection;
	
	private JLabel controllerLabel;
	
	private boolean useHub = false;
	private boolean autoAccept = false;
	
	public static void main(String[] args)
	{
		new RemoteControlServerUI(args);
	}
	
	public RemoteControlServerUI(String[] args)
	{
		super("Remote Control Server",args);
		
		try{
			if(args.length>=1)
			{
				address = args[0];
				
				if( address.indexOf("@")>0 )
				{
					useHub = true;
					alias = address.substring( 0,address.indexOf("@") );
					address = address.substring( address.indexOf("@")+1 );
					
					if(alias.indexOf(":")>0)
					{
						password = alias.substring( alias.indexOf(":")+1 );
						alias = alias.substring( 0,alias.indexOf(":"));
					}
				}
				
				if(address.indexOf(":")>0)
				{
					port = Integer.parseInt( address.substring( address.indexOf(":")+1 ));
					address = address.substring( 0,address.indexOf(":"));
				}
			}
			else
			{
				address = InetAddress.getLocalHost().getHostAddress();
			}

			if(alias==null)
			{
				alias = address+":"+port;
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.exit(1);
		}
		
		if(useHub==true)
		{
			initialiseHub();
			System.out.println("Hub connected");		
		}
		else
		{
			initialiseServer();
		}

		initialiseUI();
		
		if(args.length==2 && args[1].equals("autoAccept"))
		{
			autoAccept=true;
		}

		server.setAutoAccept(autoAccept);
	}
	
	private void initialiseUI()
	{
		getContentPane().add(new JLabel("Alias:"+alias),BorderLayout.NORTH);
		controllerLabel = new JLabel("Controller: -no connection-");
		getContentPane().add(controllerLabel,BorderLayout.SOUTH);
		this.pack();
		this.setVisible(true);
	}
	
	public void setAlias(String alias)
	{
		this.alias = alias;
	}
	
	public void setRequester(String requester)
	{
		controllerLabel.setText("Controller: "+requester);
	}
	
	private void initialiseServer()
	{
		server = new RemoteControlServer(this);
		server.start("Remote Control Server",address,port,2,1000);
	}
	
	private void initialiseHub()
	{
		server = new RemoteControlServer(this);
		try{
			if(hubConnection==null)
			{
				hubConnection = new RemoteControlHubConnection(alias,password,this,server);
			}
			
			hubConnection.connect(address,port);
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	public void disconnect()
	{
		if( useHub==true )
		{
			setRequester("-reconnecting-");
			try{ Thread.sleep(10000); }catch(Exception e){}
			
			initialiseHub();
			server.setAutoAccept(autoAccept);
			System.out.println("Hub reconnected");
			setRequester("-no connection-");
		}
	}
	
	public boolean destroy() {
		return true;
	}

	public Frame getRootFrame()
	{
		return this;
	}
	
	public ControlAdapter getControlAdapter()
	{
		return new DesktopControlAdapter();
	}
	
	public ScreenRecorder getScreenRecorder(OutputStream outputStream,ScreenRecorderListener listener)
	{
		return new DesktopScreenRecorder(outputStream,listener);
	}
}
