package org.one.stone.soup.server;

import java.net.*;
import java.io.*;

public abstract class Server implements Runnable
{
	private String alias;
	private String address;
	private int port;
	private int bufferSize;
	private long ttl;

 	private ServerSocket serverSocket;
 	private boolean running = false;

public void start(String alias,String address,int port,int bufferSize,long ttl)
{
// Init server
	this.alias = alias;
	this.address = address;
	this.port = port;
	this.bufferSize = bufferSize;
	this.ttl = ttl;

	initialize();

// Start server
	new Thread(this,alias).start();
}

public abstract void route(Socket socket, RouterThread router);

public void run() {

	try{
		serverSocket = new ServerSocket(port,bufferSize,InetAddress.getByName(address));
	}
	catch(Exception e)
	{
		e.printStackTrace();
	}

	Socket newSocket;

	running=true;

	System.out.println("Server service started on port "+port+" buffer size = "+bufferSize );
	while(running==true)
	{
		try{
			newSocket=serverSocket.accept();
		}
		catch(IOException e)
		{
			System.out.println("Failed to accept Socket." );
			return;
		}

		if(running==false) // To stop processing of new sockets once station is stopped
		{
			try{
				newSocket.close();
			}
			catch(Exception e)
			{}
			try{
				serverSocket.close();
			}
			catch(Exception e)
			{}

			break;
		}

		try{
			//System.out.println("Socket transaction accepted." );
			new RouterThread( this,newSocket,ttl );
			//System.out.println("Socket transaction routed." );
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	running = false;
	System.out.println("Server service stopped on port "+port+" buffer size = "+bufferSize );
}
	public String getAlias()
	{
		return alias;
	}

	public void stop()
	{
		running = false;
		try{
			Socket socket=new Socket(address,port);
			socket.close();
		}
		catch(Exception e)
		{
		}
		
	}
	
	public abstract void initialize();
}
