package org.one.stone.soup.stringhelper;

/*
 * Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public class BitString {
	private byte[] bits;
	private int length=0;
/**
 * BitString constructor comment.
 */
public BitString() {
	super();

	length = 0;

	bits = new byte[1];
}
/**
 * BitString constructor comment.
 */
public BitString(byte[] data) throws Exception
{
	this(data.length*8);

	for(int loop=0;loop<data.length;loop++)
	{
		setBits(loop,data[loop]);
	}
}
/**
 * BitString constructor comment.
 */
public BitString(boolean[] data) {
	super();

	this.length = data.length;

	if(length%8==0)
		bits = new byte[length/8];
	else
		bits = new byte[(length/8)+1];

	for(int loop=0;loop<bits.length;loop++)
	{
		bits[loop]=0;
	}

	for(int loop=0;loop<data.length;loop++)
	{
		try{setBit(loop,data[loop]);}catch(Exception e){}
	}
}
/**
 * BitString constructor comment.
 */
public BitString(int size) {
	super();

	length = size;

	bits = new byte[(size/8)+1];
}
/**
 * Insert the method's description here.
 * Creation date: (3/16/00 5:54:25 PM)
 * @param value boolean
 */
public void addBit(boolean value) {

	length++;

	if(bits.length<(length/8)+1)
		increaseArraySize();

	if(value==true)
	{
		byte mask = (byte)(1 << ((length-1)%8));
		bits[length/8] += mask;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (3/16/00 5:54:25 PM)
 * @param value boolean
 */
public boolean getBit(int index) throws Exception {
	if(bits.length<index/8)
		throw new Exception("BitString.getBit("+index+") index out of range.");

	byte mask = (byte)(1 << (index%8));

	if((bits[index/8] & mask) == 0)
		return false;
	else
		return true;
}
/**
 * Insert the method's description here.
 * Creation date: (3/16/00 5:54:25 PM)
 * @param value boolean
 */
public byte[] getBits(){
	return bits;
}
/**
 * Insert the method's description here.
 * Creation date: (3/16/00 5:51:21 PM)
 */
public int getLength()
{
	return length;
}
/**
 * Insert the method's description here.
 * Creation date: (3/16/00 5:51:21 PM)
 */
public int getSize()
{
	return bits.length;
}
/**
 * Insert the method's description here.
 * Creation date: (3/16/00 6:07:00 PM)
 */
private void increaseArraySize() {
	byte[] temp = new byte[bits.length+1];
	System.arraycopy(bits,0,temp,0,bits.length);
	bits[bits.length-1]=0;
	bits=temp;
}
/**
 * Insert the method's description here.
 * Creation date: (3/16/00 5:54:25 PM)
 * @param value boolean
 */
public void setBit(int index,boolean value) throws Exception {

	if(bits.length<index/8)
		throw new Exception("BitString.setBit("+index+") index out of range Max."+bits.length*8);

	byte mask = (byte)(1 << (index%8));

	if(value==true)
	{
		if((bits[index/8] & mask)==0)
			bits[index/8] += mask;
	}
	else
	{
		if((bits[index/8] & mask)!=0)
			bits[index/8] -= mask;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (3/16/00 5:54:25 PM)
 * @param value boolean
 */
public void setBits(int byteIndex,byte byteData) throws Exception {

	if(bits.length<byteIndex)
		throw new Exception("BitString.setBits("+byteIndex+") index out of range Max."+bits.length);

	bits[byteIndex]=byteData;
}
/**
 * Insert the method's description here.
 * Creation date: (3/16/00 6:03:04 PM)
 * @return java.lang.String
 */
public String toString() {
	String data = super.toString()+" Bits:[ ";

	for(int loop=0;loop<length;loop++)
	{
		try{

		if(getBit(loop)==true)
			data+="1";
		else
			data+="0";

		}catch(Exception e)
		{
			data+=e;
		}
	}

	data+=" ]";
	return data;
}
}
