package org.one.stone.soup.xapp;

import java.util.Enumeration;
import java.util.Hashtable;

import org.one.stone.soup.xapp.components.XappComponent;
import org.one.stone.soup.xapp.components.XappField;
import org.one.stone.soup.xapp.containers.XappContainer;
import org.one.stone.soup.xapp.dnd.XappDragSource;
import org.one.stone.soup.xapp.dnd.XappDropReceiver;

public class XappComponentStore {

	private Hashtable components = new Hashtable();
	private Hashtable dragSources = new Hashtable();
	private Hashtable dropTargets = new Hashtable();
	private XappComponent root;
	
	public XappComponentStore()
	{
	}
	
	public XappComponentStore(XappComponent root)
	{
		this.root = root;
	}
	
	public XappComponent getRoot()
	{
		return root;
	}
	
	public void addField(String alias,XappField component)
	{
		putComponent(alias,component);
	}
	
	public void addContainer(String alias,XappContainer component)
	{
		putComponent(alias,component);
	}
	
	public void addXappComponent(String alias,XappComponent component)
	{
		putComponent(alias,component);
	}
	
	public void addXappComponentStore(XappComponentStore store)
	{
		putAllComponents(store);
	}
	
	public XappComponent getXappComponent(String alias)
	{
		return (XappComponent)components.get(alias);
	}
	
	public void removeXappComponent(String alias)
	{
		components.remove(alias);
	}
	
	public XappField getField(String alias)
	{
		return (XappField)components.get(alias);
	}
	
	public XappComponent[] getXappComponents()
	{
		XappComponent[] componentArray = new XappComponent[components.size()];
		
		Enumeration enumeration = components.keys();
		int cursor = 0;
		while(enumeration.hasMoreElements())
		{
			componentArray[cursor] = (XappComponent)components.get(enumeration.nextElement());
			cursor++;
		}
		
		return componentArray;
	}
	
	public void addDropTarget(String alias,XappDropReceiver target)
	{
		dropTargets.put(alias,target);
	}
	
	public XappDropReceiver getDropTarget(String alias)
	{
		return (XappDropReceiver)dropTargets.get(alias);
	}
	
	public void addDragSource(String alias,XappDragSource source)
	{
		dragSources.put(alias,source);
	}
	
	public XappDragSource getDragSource(String alias)
	{
		return (XappDragSource)dragSources.get(alias);
	}

	private void putAllComponents(XappComponentStore store)
	{
		XappComponent[] components = store.getXappComponents();
		for(int loop=0;loop<components.length;loop++)
		{
			putComponent( components[loop].getName(),components[loop] );
		}
	}

	private void putComponent(String alias,XappComponent component)
	{
		/*boolean put = true;
		if(components.get(alias)!=null)
		{
			put = XappRootApplication.askForConfirmation("Warning: "+alias+" already exists. Replace with new ?");
		}
		
		if(put)
		{*/
			components.put(alias,component);
		/*}*/
	}
}
