package org.one.stone.soup.xapp.controller.xml;

import java.io.File;

import javax.swing.ImageIcon;

import org.one.stone.soup.stringhelper.StringArrayHelper;
import org.one.stone.soup.stringhelper.StringParser;
import org.one.stone.soup.xapp.XappRootApplication;
import org.one.stone.soup.xml.XmlElement;
import org.one.stone.soup.xml.helper.XmlPathSearch;

public class XmlSchemaViewController {

	private File root;
	//private XmlElement xView;
	private XmlPathSearch xViewSearch;
	
	XmlSchemaViewController(File root,XmlElement xView)
	{
		this.root = root;
		//this.xView = xView;
		xViewSearch = new XmlPathSearch(xView);
	}
	
	public File getRoot()
	{
		return root;
	}
	
	public String getIconFileNameForNode(XmlElement node,boolean expanded)
	{
		if(node==null)
		{
			return null;
		}
    	XmlElement xIcon = null;
		if( expanded )
		{
			xIcon = xViewSearch.findElement("treeView/nodeView[@name='"+node.getName()+"']/iconOpen");
		}
		if(xIcon==null)
		{
			xIcon = xViewSearch.findElement("treeView/nodeView[@name='"+node.getName()+"']/icon");
		}
		if(xIcon==null)
		{
			xIcon = xViewSearch.findElement("treeView/defaultView/icon");
		}

		if(xIcon==null)
		{
			return null;
		}
		String fileName = xIcon.getAttributeValueByName("file");
		if(fileName.length()>2 && fileName.substring(0,2).equals("./"))
		{
			fileName = fileName.substring(2);
			return root.getAbsolutePath()+"/"+fileName;
		}
		else
		{
			return XappRootApplication.getRoot().getApplicationFileRoot()+fileName;
		}
	}
	public String getNameForNode(XmlElement node)
	{
		if(node==null)
		{
			return "";
		}
		
		String name=node.getName();
		String builtName="";
		XmlElement view = xViewSearch.findElement("treeView/nodeView[@name='"+node.getName()+"']");
		if(view!=null)
		{
			String viewName = view.getAttributeValueByName("viewName");
			if(viewName==null)
			{
				return view.getAttributeValueByName("name");
			}
			
			String [] viewNames = StringArrayHelper.parseFields(viewName,'+');
			String newName = null;
			for(int loop=0;loop<viewNames.length;loop++)
			{
				newName = null;
				if(viewNames[loop].equals("[BLANK]"))
				{
					newName="";
				}
				else if(viewNames[loop].equals("[NAME]"))
				{
					newName=name;
				}
				else if(viewNames[loop].charAt(0)=='[')
				{
					newName=StringParser.getInside(viewNames[loop],'[',']');
				}
				else
				{
					if(viewNames[loop].length()>0 && viewNames[loop].charAt(0)=='@')
					{
						newName = node.getAttributeValueByName(viewNames[loop].substring(1));
					}
					else if(viewNames[loop].length()==1 && viewNames[loop].equals("/"))
					{
						newName=node.getValue();
					}
					else
					{
						String attributeName = null;
						if(viewNames[loop].indexOf('@')>0)
						{
							attributeName = viewNames[loop].substring( viewNames[loop].indexOf('@')+1 );
							viewNames[loop] = viewNames[loop].substring( 0,viewNames[loop].indexOf('@') );
						}
						
						XmlPathSearch search = new XmlPathSearch( node );
						XmlElement viewResult = search.findElements( node.getName()+"/"+viewNames[loop]);
						if( viewResult!=null )
						{
							for(int loopV=0;loopV<viewResult.getElementCount();loopV++)
							{
								if(newName!=null)
								{
									newName+=" ";
								}
									
								view = viewResult.getElementByIndex(loopV);
								if( attributeName==null && view.getValue()!=null)
								{
									if(newName==null)
									{
										newName="";
									}
									newName+=view.getValue();
								}
								else if(attributeName.equals("[NAME]"))
								{
									String data = getNameForNode(view);
									if(data!=null)
									{
										if(newName==null)
										{
											newName="";
										}
										
										newName+=data;
									}
								}
								else if(view.getAttributeValueByName(attributeName)!=null)
								{
									if(newName==null)
									{
										newName="";
									}
									newName += view.getAttributeValueByName(attributeName);
								}
							}
						}
					}
				}
				if(newName==null)
				{
					continue;
				}
				
				if(loop>0)
				{
					builtName = builtName+" ";
				}
				builtName = builtName+newName;
			}
		}
		if(builtName!=null || builtName.length()==0)
		{
			return builtName;
		}
		
		return name;		
	}
	
	public XmlElement getFormForNode(XmlElement node)
	{
		return xViewSearch.findElement("treeView/nodeView[@name='"+node.getName()+"']/form");		
	}
}
