package org.one.stone.soup.xapp.swing.components;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JDesktopPane;
import javax.swing.JInternalFrame;

import org.one.stone.soup.xapp.XappRootApplication;
import org.one.stone.soup.xapp.components.XappComponent;
import org.one.stone.soup.xapp.containers.XappDesktop;
import org.one.stone.soup.xml.XmlElement;

public class XappSwingDesktop extends JDesktopPane implements XappDesktop{

	public void add(String name, XappComponent component) {
		addApplication(component);
	}

	public void add(XappComponent component) {
		addApplication(component);
	}

	public void refresh() {
		doLayout();
	}

	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void addActionListener(ActionListener actionListener) {
		// TODO Auto-generated method stub
		
	}

	public void setTip(String toolTip) {
		setToolTipText(toolTip);
	}

	
	public void addApplication(XappComponent component)
	{
		JInternalFrame frame = new JInternalFrame( component.getName(),true );
		frame.setMaximizable(true);
		frame.setClosable(true);
		frame.setIconifiable(true);
	
		frame.getContentPane().add( (Component)component );

		
		frame.pack();
		frame.show(true);

		super.add(frame);
	}
	
	public void addApplication(XmlElement application)
	{
		JInternalFrame frame = new JInternalFrame( application.getAttributeValueByName("title"),true );
		frame.setMaximizable(true);
		frame.setClosable(true);
		frame.setIconifiable(true);
	
		XmlElement contents = application.getElementByName("container");
	
		if(contents!=null)
		{
			contents = contents.getElementByIndex(0);
			if(contents!=null)
			{
				frame.getContentPane().add( (Component)XappRootApplication.getComponentFactory().buildContainer(contents,XappRootApplication.getComponentStore()) );
				//frame.add( buildContainer(contents,componentStore) );
			}
		}
		
		frame.pack();
		frame.show(true);

		super.add(frame);
	}
}
